Index: NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lbc_nfd_generic.h90
===================================================================
--- NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lbc_nfd_generic.h90	(revision 14349)
+++ NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lbc_nfd_generic.h90	(revision 14363)
@@ -242,32 +249,32 @@
                DO jl = 1, ipl; DO jk = 1, ipk
                   !
-                  ! last nn_hls lines (from ipj to ipj-nn_hls+1) : full
-               	  DO jj = 1, nn_hls
-               	     ij1 = ipj + 1        - jj           ! ends at: ipj + 1 - nn_hls
-                     ij2 = ipj - 2*nn_hls + jj           ! ends at: ipj - 2*nn_hls + nn_hls = ipj - nn_hls
-                     !
-                     DO ji = 1, nn_hls-1          ! first nn_hls-1 points
-                        ii1 =            ji              ! ends at: nn_hls-1
-                        ii2 = 2*nn_hls - ji              ! ends at: 2*nn_hls - ( nn_hls - 1 ) = nn_hls + 1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     DO ji = 1, 1                 ! point nn_hls
-                        ii1 = nn_hls + ji - 1
-                        ii2 = jpiglo - ii1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     DO ji = 1, Ni0glo - 1        ! points from nn_hls+1 to jpiglo - nn_hls - 1  (note: Ni0glo = jpiglo - 2*nn_hls)
-                        ii1 =          nn_hls + ji       ! ends at: nn_hls + ( jpiglo - 2*nn_hls - 1 ) = jpiglo - nn_hls - 1
-                        ii2 = jpiglo - nn_hls - ji       ! ends at: jpiglo - nn_hls - ( jpiglo - 2*nn_hls - 1 ) = nn_hls + 1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     DO ji = 1, 1                 ! point jpiglo - nn_hls
-                        ii1 = jpiglo - nn_hls + ji - 1
+                  ! last khls lines (from ipj to ipj-khls+1) : full
+               	  DO jj = 1, khls
+               	     ij1 = ipj + 1      - jj             ! ends at: ipj + 1 - khls
+                     ij2 = ipj - 2*khls + jj             ! ends at: ipj - 2*khls + khls = ipj - khls
+                     !
+                     DO ji = 1, khls-1            ! first khls-1 points
+                        ii1 =          ji                ! ends at: khls-1
+                        ii2 = 2*khls - ji                ! ends at: 2*khls - ( khls - 1 ) = khls + 1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     DO ji = 1, 1                 ! point khls
+                        ii1 = khls + ji - 1
+                        ii2 = ipi - ii1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     DO ji = 1, Ni0glo - 1        ! points from khls+1 to ipi - khls - 1  (note: Ni0glo = ipi - 2*khls)
+                        ii1 =       khls + ji            ! ends at: khls + ( ipi - 2*khls - 1 ) = ipi - khls - 1
+                        ii2 = ipi - khls - ji            ! ends at: ipi - khls - ( ipi - 2*khls - 1 ) = khls + 1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     DO ji = 1, 1                 ! point ipi - khls
+                        ii1 = ipi - khls + ji - 1
                         ii2 = ii1
                         ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
                      END DO
-                     DO ji = 1, nn_hls            ! last nn_hls points
-                        ii1 = jpiglo - nn_hls + ji       ! ends at: jpiglo - nn_hls + nn_hls = jpiglo
-                        ii2 = jpiglo - nn_hls - ji       ! ends at: jpiglo - nn_hls - nn_hls = jpiglo - 2*nn_hls
+                     DO ji = 1, khls              ! last khls points
+                        ii1 = ipi - khls + ji            ! ends at: ipi - khls + khls = ipi
+                        ii2 = ipi - khls - ji            ! ends at: ipi - khls - khls = ipi - 2*khls
                         ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
                      END DO
@@ -278,43 +285,43 @@
                DO jl = 1, ipl; DO jk = 1, ipk
                   !
-                  ! last nn_hls lines (from ipj to ipj-nn_hls+1) : full
-               	  DO jj = 1, nn_hls
-               	     ij1 = ipj            - jj + 1       ! ends at: ipj - nn_hls + 1
-                     ij2 = ipj - 2*nn_hls + jj - 1       ! ends at: ipj - 2*nn_hls + nn_hls - 1 = ipj - nn_hls - 1
-                     !
-                     DO ji = 1, nn_hls            ! first nn_hls points
-                        ii1 =                ji          ! ends at: nn_hls
-                        ii2 = 2*nn_hls + 1 - ji          ! ends at: 2*nn_hls + 1 - nn_hls = nn_hls + 1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     DO ji = 1, Ni0glo            ! points from nn_hls to jpiglo - nn_hls   (note: Ni0glo = jpiglo - 2*nn_hls)
-                        ii1 = nn_hls          + ji       ! ends at: nn_hls + jpiglo - 2*nn_hls = jpiglo - nn_hls
-                        ii2 = jpiglo - nn_hls - ji + 1   ! ends at: jpiglo - nn_hls - ( jpiglo - 2*nn_hls ) + 1 = nn_hls + 1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     DO ji = 1, nn_hls            ! last nn_hls points
-                        ii1 = jpiglo - nn_hls + ji       ! ends at: jpiglo - nn_hls + nn_hls = jpiglo
-                        ii2 = jpiglo - nn_hls + 1 - ji   ! ends at: jpiglo - nn_hls + 1 - nn_hls = jpiglo - 2*nn_hls + 1
+                  ! last khls lines (from ipj to ipj-khls+1) : full
+               	  DO jj = 1, khls
+               	     ij1 = ipj          - jj + 1         ! ends at: ipj - khls + 1
+                     ij2 = ipj - 2*khls + jj - 1         ! ends at: ipj - 2*khls + khls - 1 = ipj - khls - 1
+                     !
+                     DO ji = 1, khls              ! first khls points
+                        ii1 =              ji            ! ends at: khls
+                        ii2 = 2*khls + 1 - ji            ! ends at: 2*khls + 1 - khls = khls + 1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     DO ji = 1, Ni0glo            ! points from khls to ipi - khls   (note: Ni0glo = ipi - 2*khls)
+                        ii1 =       khls + ji          ! ends at: khls + ipi - 2*khls = ipi - khls
+                        ii2 = ipi - khls - ji + 1      ! ends at: ipi - khls - ( ipi - 2*khls ) + 1 = khls + 1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     DO ji = 1, khls            ! last khls points
+                        ii1 = ipi - khls + ji          ! ends at: ipi - khls + khls = ipi
+                        ii2 = ipi - khls + 1 - ji      ! ends at: ipi - khls + 1 - khls = ipi - 2*khls + 1
                         ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
                      END DO
                   END DO   
                   !
-                  ! line number ipj-nn_hls : right half
-               	  DO jj = 1, 1
-                     ij1 = ipj - nn_hls
-                     ij2 = ij1   ! same line
-                     !
-                     DO ji = 1, Ni0glo/2          ! points from jpiglo/2+1 to jpiglo - nn_hls   (note: Ni0glo = jpiglo - 2*nn_hls)
-                        ii1 = jpiglo/2 + ji              ! ends at: jpiglo/2 + (jpiglo/2 - nn_hls) = jpiglo - nn_hls
-                        ii2 = jpiglo/2 - ji + 1          ! ends at: jpiglo/2 - (jpiglo/2 - nn_hls) + 1 = nn_hls + 1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     DO ji = 1, nn_hls            ! first nn_hls points: redo them just in case (if e-w periodocity already done)
-                        !                         ! as we just changed points jpiglo-2nn_hls+1 to jpiglo-nn_hls  
-                        ii1 =                ji          ! ends at: nn_hls
-                        ii2 = 2*nn_hls + 1 - ji          ! ends at: 2*nn_hls + 1 - nn_hls = nn_hls + 1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     !                            ! last nn_hls points: have been / will done by e-w periodicity 
+                  ! line number ipj-khls : right half
+               	  DO jj = 1, 1
+                     ij1 = ipj - khls
+                     ij2 = ij1   ! same line
+                     !
+                     DO ji = 1, Ni0glo/2          ! points from ipi/2+1 to ipi - khls   (note: Ni0glo = ipi - 2*khls)
+                        ii1 = ipi/2 + ji                 ! ends at: ipi/2 + (ipi/2 - khls) = ipi - khls
+                        ii2 = ipi/2 - ji + 1             ! ends at: ipi/2 - (ipi/2 - khls) + 1 = khls + 1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     DO ji = 1, khls              ! first khls points: redo them just in case (if e-w periodocity already done)
+                        !                         ! as we just changed points ipi-2khls+1 to ipi-khls  
+                        ii1 =              ji            ! ends at: khls
+                        ii2 = 2*khls + 1 - ji            ! ends at: 2*khls + 1 - khls = khls + 1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     !                            ! last khls points: have been / will done by e-w periodicity 
                   END DO
                   !
@@ -323,53 +330,53 @@
                DO jl = 1, ipl; DO jk = 1, ipk
                   !
-                  ! last nn_hls lines (from ipj to ipj-nn_hls+1) : full
-               	  DO jj = 1, nn_hls
-               	     ij1 = ipj            - jj + 1       ! ends at: ipj - nn_hls + 1
-                     ij2 = ipj - 2*nn_hls + jj - 1       ! ends at: ipj - 2*nn_hls + nn_hls - 1 = ipj - nn_hls - 1
-                     !
-                     DO ji = 1, nn_hls-1          ! first nn_hls-1 points
-                        ii1 =            ji              ! ends at: nn_hls-1
-                        ii2 = 2*nn_hls - ji              ! ends at: 2*nn_hls - ( nn_hls - 1 ) = nn_hls + 1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     DO ji = 1, 1                 ! point nn_hls
-                        ii1 = nn_hls + ji - 1
-                        ii2 = jpiglo - ii1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     DO ji = 1, Ni0glo - 1        ! points from nn_hls+1 to jpiglo - nn_hls - 1  (note: Ni0glo = jpiglo - 2*nn_hls)
-                        ii1 =          nn_hls + ji       ! ends at: nn_hls + ( jpiglo - 2*nn_hls - 1 ) = jpiglo - nn_hls - 1
-                        ii2 = jpiglo - nn_hls - ji       ! ends at: jpiglo - nn_hls - ( jpiglo - 2*nn_hls - 1 ) = nn_hls + 1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     DO ji = 1, 1                 ! point jpiglo - nn_hls
-                        ii1 = jpiglo - nn_hls + ji - 1
+                  ! last khls lines (from ipj to ipj-khls+1) : full
+               	  DO jj = 1, khls
+               	     ij1 = ipj          - jj + 1         ! ends at: ipj - khls + 1
+                     ij2 = ipj - 2*khls + jj - 1         ! ends at: ipj - 2*khls + khls - 1 = ipj - khls - 1
+                     !
+                     DO ji = 1, khls-1            ! first khls-1 points
+                        ii1 =          ji                ! ends at: khls-1
+                        ii2 = 2*khls - ji                ! ends at: 2*khls - ( khls - 1 ) = khls + 1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     DO ji = 1, 1                 ! point khls
+                        ii1 = khls + ji - 1
+                        ii2 = ipi - ii1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     DO ji = 1, Ni0glo - 1        ! points from khls+1 to ipi - khls - 1  (note: Ni0glo = ipi - 2*khls)
+                        ii1 =       khls + ji            ! ends at: khls + ( ipi - 2*khls - 1 ) = ipi - khls - 1
+                        ii2 = ipi - khls - ji            ! ends at: ipi - khls - ( ipi - 2*khls - 1 ) = khls + 1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     DO ji = 1, 1                 ! point ipi - khls
+                        ii1 = ipi - khls + ji - 1
                         ii2 = ii1
                         ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
                      END DO
-                     DO ji = 1, nn_hls            ! last nn_hls points
-                        ii1 = jpiglo - nn_hls + ji       ! ends at: jpiglo - nn_hls + nn_hls = jpiglo
-                        ii2 = jpiglo - nn_hls - ji       ! ends at: jpiglo - nn_hls - nn_hls = jpiglo - 2*nn_hls
+                     DO ji = 1, khls              ! last khls points
+                        ii1 = ipi - khls + ji            ! ends at: ipi - khls + khls = ipi
+                        ii2 = ipi - khls - ji            ! ends at: ipi - khls - khls = ipi - 2*khls
                         ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
                      END DO
                   END DO   
                   !
-                  ! line number ipj-nn_hls : right half
-               	  DO jj = 1, 1
-                     ij1 = ipj - nn_hls
-                     ij2 = ij1   ! same line
-                     !
-                     DO ji = 1, Ni0glo/2-1        ! points from jpiglo/2+1 to jpiglo - nn_hls-1  (note: Ni0glo = jpiglo - 2*nn_hls)
-                        ii1 = jpiglo/2 + ji              ! ends at: jpiglo/2 + (jpiglo/2 - nn_hls) = jpiglo - nn_hls
-                        ii2 = jpiglo/2 - ji              ! ends at: jpiglo/2 - (jpiglo/2 - nn_hls - 1 ) = nn_hls + 1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     DO ji = 1, nn_hls-1          ! first nn_hls-1 points: redo them just in case (if e-w periodocity already done)
-                        !                         ! as we just changed points jpiglo-2nn_hls+1 to jpiglo-nn_hl-1  
-                        ii1 =            ji              ! ends at: nn_hls
-                        ii2 = 2*nn_hls - ji              ! ends at: 2*nn_hls - ( nn_hls - 1 ) = nn_hls + 1
-                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
-                     END DO
-                     !                            ! last nn_hls points: have been / will done by e-w periodicity 
+                  ! line number ipj-khls : right half
+               	  DO jj = 1, 1
+                     ij1 = ipj - khls
+                     ij2 = ij1   ! same line
+                     !
+                     DO ji = 1, Ni0glo/2-1        ! points from ipi/2+1 to ipi - khls-1  (note: Ni0glo = ipi - 2*khls)
+                        ii1 = ipi/2 + ji                 ! ends at: ipi/2 + (ipi/2 - khls) = ipi - khls
+                        ii2 = ipi/2 - ji                 ! ends at: ipi/2 - (ipi/2 - khls - 1 ) = khls + 1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     DO ji = 1, khls-1            ! first khls-1 points: redo them just in case (if e-w periodocity already done)
+                        !                         ! as we just changed points ipi-2khls+1 to ipi-nn_hl-1  
+                        ii1 =          ji                ! ends at: khls
+                        ii2 = 2*khls - ji                ! ends at: 2*khls - ( khls - 1 ) = khls + 1
+                        ptab(jf)%pt4d(ii1,ij1,jk,jl) = psgn(jf) * ptab(jf)%pt4d(ii2,ij2,jk,jl)
+                     END DO
+                     !                            ! last khls points: have been / will done by e-w periodicity 
                   END DO
                   !
Index: NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lbc_nfd_nogather_generic.h90
===================================================================
--- NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lbc_nfd_nogather_generic.h90	(revision 14349)
+++ NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lbc_nfd_nogather_generic.h90	(revision 14363)
@@ -1,4 +1,4 @@
 
-   SUBROUTINE lbc_nfd_nogather_/**/PRECISION( ptab, ptab2, cd_nat, psgn )
+   SUBROUTINE lbc_nfd_nogather_/**/PRECISION( ptab, ptab2, cd_nat, psgn, khls )
       !!----------------------------------------------------------------------
       !!
@@ -11,4 +11,5 @@
       CHARACTER(len=1)                    , INTENT(in   ) ::   cd_nat      ! nature of array grid-points
       REAL(PRECISION)                     , INTENT(in   ) ::   psgn        ! sign used across the north fold boundary
+      INTEGER                             , INTENT(in   ) ::   khls        ! halo size, default = nn_hls
       !
       INTEGER  ::    ji,  jj, jk,  jn,  jl, jh       ! dummy loop indices
@@ -29,9 +30,9 @@
          CASE ( 'T' , 'W' )                         ! T-, W-point
             IF ( nimpp /= 1 ) THEN  ;  startloop = 1 
-            ELSE                    ;  startloop = 1 + nn_hls
-            ENDIF
-            !
-            DO jl = 1, ipl; DO jk = 1, ipk
-               DO jj = 1, nn_hls
+            ELSE                    ;  startloop = 1 + khls
+            ENDIF
+            !
+            DO jl = 1, ipl; DO jk = 1, ipk
+               DO jj = 1, khls
                   ijj = jpj -jj +1
                   DO ji = startloop, jpi
@@ -43,8 +44,8 @@
             IF( nimpp == 1 ) THEN
                DO jl = 1, ipl; DO jk = 1, ipk
-                  DO jj = 1, nn_hls
+                  DO jj = 1, khls
                      ijj = jpj -jj +1
-                     DO ii = 0, nn_hls-1
-                        ptab(ii+1,ijj,jk,jl) = psgn * ptab(2*nn_hls-ii+1,jpj-2*nn_hls+jj-1,jk,jl)
+                     DO ii = 0, khls-1
+                        ptab(ii+1,ijj,jk,jl) = psgn * ptab(2*khls-ii+1,jpj-2*khls+jj-1,jk,jl)
                      END DO
                   END DO
@@ -56,5 +57,5 @@
                   startloop = 1
                ELSEIF( nimpp+jpi-1 >= Ni0glo/2+2 .AND. nimpp < Ni0glo/2+2 ) THEN
-                  startloop = Ni0glo/2+2 - nimpp + nn_hls
+                  startloop = Ni0glo/2+2 - nimpp + khls
                ELSE
                   startloop = jpi + 1
@@ -67,7 +68,7 @@
                         ijta = jpiglo - jia + 2
                         IF( ijta >= startloop+nimpp-1 .AND. ijta < jia ) THEN
-                           ptab(ji,jpj-nn_hls,jk,jl) = psgn * ptab(ijta-nimpp+nn_hls,jpj-nn_hls,jk,jl)
+                           ptab(ji,jpj-khls,jk,jl) = psgn * ptab(ijta-nimpp+khls,jpj-khls,jk,jl)
                         ELSE
-                           ptab(ji,jpj-nn_hls,jk,jl) = psgn * ptab2(ijt,nn_hls+1,jk,jl)
+                           ptab(ji,jpj-khls,jk,jl) = psgn * ptab2(ijt,khls+1,jk,jl)
                         ENDIF
                      END DO
@@ -79,8 +80,8 @@
                endloop = jpi
             ELSE
-               endloop = jpi - nn_hls
-            ENDIF
-            DO jl = 1, ipl; DO jk = 1, ipk
-               DO jj = 1, nn_hls
+               endloop = jpi - khls
+            ENDIF
+            DO jl = 1, ipl; DO jk = 1, ipk
+               DO jj = 1, khls
                   ijj = jpj -jj +1
                   DO ji = 1, endloop
@@ -91,16 +92,16 @@
             END DO; END DO
             IF (nimpp .eq. 1) THEN
-               DO jj = 1, nn_hls
-                  ijj = jpj -jj +1
-                  DO ii = 0, nn_hls-1
-                     ptab(ii+1,ijj,:,:) = psgn * ptab(2*nn_hls-ii,jpj-2*nn_hls+jj-1,:,:)
+               DO jj = 1, khls
+                  ijj = jpj -jj +1
+                  DO ii = 0, khls-1
+                     ptab(ii+1,ijj,:,:) = psgn * ptab(2*khls-ii,jpj-2*khls+jj-1,:,:)
                   END DO
                END DO
             ENDIF
             IF((nimpp + jpi - 1) .eq. jpiglo) THEN
-               DO jj = 1, nn_hls
-                  ijj = jpj -jj +1
-                  DO ii = 1, nn_hls
-                     ptab(jpi-ii+1,ijj,:,:) = psgn * ptab(jpi-2*nn_hls+ii,jpj-2*nn_hls+jj-1,:,:)
+               DO jj = 1, khls
+                  ijj = jpj -jj +1
+                  DO ii = 1, khls
+                     ptab(jpi-ii+1,ijj,:,:) = psgn * ptab(jpi-2*khls+ii,jpj-2*khls+jj-1,:,:)
                   END DO
                END DO
@@ -111,10 +112,10 @@
                   endloop = jpi
                ELSE
-                  endloop = jpi - nn_hls
+                  endloop = jpi - khls
                ENDIF
                IF( nimpp >= Ni0glo/2+1 ) THEN
-                  startloop = nn_hls
+                  startloop = khls
                ELSEIF( ( nimpp + jpi - 1 >= Ni0glo/2+1 ) .AND. ( nimpp < Ni0glo/2+1 ) ) THEN
-                  startloop = Ni0glo/2+1 - nimpp + nn_hls 
+                  startloop = Ni0glo/2+1 - nimpp + khls 
                ELSE
                   startloop = endloop + 1
@@ -127,7 +128,7 @@
                         ijua = jpiglo - jia + 1 
                         IF( ijua >= startloop+nimpp-1 .AND. ijua < jia ) THEN
-                           ptab(ji,jpj-nn_hls,jk,jl) = psgn * ptab(ijua-nimpp+1,jpj-nn_hls,jk,jl)
+                           ptab(ji,jpj-khls,jk,jl) = psgn * ptab(ijua-nimpp+1,jpj-khls,jk,jl)
                         ELSE
-                           ptab(ji,jpj-nn_hls,jk,jl) = psgn * ptab2(iju,nn_hls+1,jk,jl)
+                           ptab(ji,jpj-khls,jk,jl) = psgn * ptab2(iju,khls+1,jk,jl)
                         ENDIF
                      END DO
@@ -140,9 +141,9 @@
                startloop = 1 
             ELSE
-               startloop = 1 + nn_hls
-            ENDIF
-            IF ( .NOT. l_fast_exchanges ) THEN
-               DO jl = 1, ipl; DO jk = 1, ipk
-                  DO jj = 2, nn_hls+1
+               startloop = 1 + khls
+            ENDIF
+            IF ( .NOT. l_fast_exchanges ) THEN
+               DO jl = 1, ipl; DO jk = 1, ipk
+                  DO jj = 2, khls+1
                      ijj = jpj -jj +1
                      DO ji = startloop, jpi
@@ -160,8 +161,8 @@
             END DO; END DO
             IF (nimpp .eq. 1) THEN
-               DO jj = 1, nn_hls
+               DO jj = 1, khls
                   ijj = jpj-jj+1
-                  DO ii = 0, nn_hls-1
-                     ptab(ii+1,ijj,:,:) = psgn * ptab(2*nn_hls-ii+1,jpj-2*nn_hls+jj-1,:,:)
+                  DO ii = 0, khls-1
+                     ptab(ii+1,ijj,:,:) = psgn * ptab(2*khls-ii+1,jpj-2*khls+jj-1,:,:)
                   END DO
                END DO
@@ -171,9 +172,9 @@
                endloop = jpi
             ELSE
-               endloop = jpi - nn_hls
-            ENDIF
-            IF ( .NOT. l_fast_exchanges ) THEN
-               DO jl = 1, ipl; DO jk = 1, ipk
-                  DO jj = 2, nn_hls+1
+               endloop = jpi - khls
+            ENDIF
+            IF ( .NOT. l_fast_exchanges ) THEN
+               DO jl = 1, ipl; DO jk = 1, ipk
+                  DO jj = 2, khls+1
                      ijj = jpj -jj +1
                      DO ji = 1, endloop
@@ -191,12 +192,12 @@
             END DO; END DO
             IF (nimpp .eq. 1) THEN               
-               DO ii = 1, nn_hls
-                  ptab(ii,jpj,:,:) = psgn * ptab(2*nn_hls-ii,jpj-2*nn_hls-1,:,:)
+               DO ii = 1, khls
+                  ptab(ii,jpj,:,:) = psgn * ptab(2*khls-ii,jpj-2*khls-1,:,:)
                END DO
                IF ( .NOT. l_fast_exchanges ) THEN
-                  DO jj = 1, nn_hls
+                  DO jj = 1, khls
                      ijj = jpj -jj
-                     DO ii = 0, nn_hls-1
-                        ptab(ii+1,ijj,:,:) = psgn * ptab(2*nn_hls-ii,jpj-2*nn_hls+jj-1,:,:)
+                     DO ii = 0, khls-1
+                        ptab(ii+1,ijj,:,:) = psgn * ptab(2*khls-ii,jpj-2*khls+jj-1,:,:)
                      END DO
                   END DO
@@ -204,12 +205,12 @@
             ENDIF
             IF((nimpp + jpi - 1 ) .eq. jpiglo) THEN
-               DO ii = 1, nn_hls
-                  ptab(jpi-ii+1,jpj,:,:) = psgn * ptab(jpi-2*nn_hls+ii,jpj-2*nn_hls-1,:,:)
+               DO ii = 1, khls
+                  ptab(jpi-ii+1,jpj,:,:) = psgn * ptab(jpi-2*khls+ii,jpj-2*khls-1,:,:)
                END DO
                IF ( .NOT. l_fast_exchanges ) THEN
-                  DO jj = 1, nn_hls
+                  DO jj = 1, khls
                      ijj = jpj -jj
-                     DO ii = 1, nn_hls
-                        ptab(jpi-ii+1,ijj,:,:) = psgn * ptab(jpi-2*nn_hls+ii,jpj-2*nn_hls+jj-1,:,:)
+                     DO ii = 1, khls
+                        ptab(jpi-ii+1,ijj,:,:) = psgn * ptab(jpi-2*khls+ii,jpj-2*khls+jj-1,:,:)
                      END DO
                   END DO
@@ -226,5 +227,5 @@
          CASE ( 'T' , 'W' )                               ! T-, W-point
             DO jl = 1, ipl; DO jk = 1, ipk
-               DO jj = 1, nn_hls
+               DO jj = 1, khls
                   ijj = jpj-jj+1
                   DO ji = 1, jpi
@@ -239,8 +240,8 @@
                endloop = jpi
             ELSE
-               endloop = jpi - nn_hls
-            ENDIF
-            DO jl = 1, ipl; DO jk = 1, ipk
-               DO jj = 1, nn_hls
+               endloop = jpi - khls
+            ENDIF
+            DO jl = 1, ipl; DO jk = 1, ipk
+               DO jj = 1, khls
                   ijj = jpj-jj+1
                   DO ji = 1, endloop
@@ -252,9 +253,9 @@
             IF(nimpp + jpi - 1 .eq. jpiglo) THEN
                DO jl = 1, ipl; DO jk = 1, ipk
-                  DO jj = 1, nn_hls
+                  DO jj = 1, khls
                      ijj = jpj-jj+1
-                     DO ii = 1, nn_hls
+                     DO ii = 1, khls
                         iij = jpi-ii+1
-                        ptab(iij,ijj,jk,jl) = psgn * ptab(jpi-2*nn_hls+ii-1,jpj-2*nn_hls+jj,jk,jl)
+                        ptab(iij,ijj,jk,jl) = psgn * ptab(jpi-2*khls+ii-1,jpj-2*khls+jj,jk,jl)
                      END DO
                   END DO
@@ -264,5 +265,5 @@
          CASE ( 'V' )                                     ! V-point
             DO jl = 1, ipl; DO jk = 1, ipk
-               DO jj = 1, nn_hls
+               DO jj = 1, khls
                   ijj = jpj -jj +1
                   DO ji = 1, jpi
@@ -277,5 +278,5 @@
                   startloop = 1
                ELSEIF( nimpp+jpi-1 >= Ni0glo/2+2 .AND. nimpp < Ni0glo/2+2 ) THEN
-                  startloop = Ni0glo/2+2 - nimpp + nn_hls
+                  startloop = Ni0glo/2+2 - nimpp + khls
                ELSE
                   startloop = jpi + 1
@@ -285,5 +286,5 @@
                      DO ji = startloop, jpi
                         ijt = jpiglo - ji - nimpp - nfimpp(isendto(1)) + 3
-                        ptab(ji,jpj-nn_hls,jk,jl) = psgn * ptab2(ijt,nn_hls+1,jk,jl)
+                        ptab(ji,jpj-khls,jk,jl) = psgn * ptab2(ijt,khls+1,jk,jl)
                      END DO
                   END DO; END DO
@@ -295,8 +296,8 @@
                endloop = jpi
             ELSE
-               endloop = jpi - nn_hls
-            ENDIF
-            DO jl = 1, ipl; DO jk = 1, ipk
-               DO jj = 1, nn_hls
+               endloop = jpi - khls
+            ENDIF
+            DO jl = 1, ipl; DO jk = 1, ipk
+               DO jj = 1, khls
                   ijj = jpj -jj +1
                   DO ji = 1, endloop
@@ -308,9 +309,9 @@
             IF((nimpp + jpi - 1) .eq. jpiglo) THEN
                DO jl = 1, ipl; DO jk = 1, ipk
-                  DO jj = 1, nn_hls
+                  DO jj = 1, khls
                      ijj = jpj -jj +1
-                     DO ii = 1, nn_hls
+                     DO ii = 1, khls
                         iij = jpi -ii+1
-                        ptab(iij,ijj,jk,jl) = psgn * ptab(jpi-2*nn_hls+ii-1,jpj-2*nn_hls+jj-1,jk,jl)
+                        ptab(iij,ijj,jk,jl) = psgn * ptab(jpi-2*khls+ii-1,jpj-2*khls+jj-1,jk,jl)
                      END DO
                   END DO
@@ -322,10 +323,10 @@
                   endloop = jpi
                ELSE
-                  endloop = jpi - nn_hls
+                  endloop = jpi - khls
                ENDIF
                IF( nimpp >= Ni0glo/2+2 ) THEN
                   startloop = 1 
                ELSEIF( nimpp+jpi-1 >= Ni0glo/2+2 .AND. nimpp < Ni0glo/2+2 ) THEN
-                  startloop = Ni0glo/2+2 - nimpp + nn_hls
+                  startloop = Ni0glo/2+2 - nimpp + khls
                ELSE
                   startloop = endloop + 1
@@ -335,5 +336,5 @@
                      DO ji = startloop, endloop
                         iju = jpiglo - ji - nimpp - nfimpp(isendto(1)) + 2
-                        ptab(ji,jpj-nn_hls,jk,jl) = psgn * ptab2(iju,nn_hls+1,jk,jl)
+                        ptab(ji,jpj-khls,jk,jl) = psgn * ptab2(iju,khls+1,jk,jl)
                      END DO
                   END DO; END DO
